#pragma once

#include "SensorManager.h"
#include "TMutex.h"
#include "TH2.h"
class SensorManager;
struct DataStructure
{
	//Generic Sensor Properties:
	int Exposure;
	int Gain;

	//DCam Specific Sensor Properties:
	int SensorType;

	//Generic Data Properties:
	int pHight;
	int pWidth;

	//Pointer to the beggining of the data:
	int* pData;
};

class ControlCenter: public TObject
{
public:
	ControlCenter();
	~ControlCenter();

	bool ControlCenterInitialise();
	bool SnapShot();
	bool BeginMonitoring();
	bool StopMonitoring();

private:
	TH2* th2;
	//Data  Structures:
	DataStructure* stDataStructure;

#ifdef _SENSOR_MANAGER
	SensorManager* sensorManager;
#endif
	ClassDef(ControlCenter,1);
};
