// GMD Field Probe.cpp : Entry point to the Application.
//

#pragma region Project Includes
#include "stdafx.h"
#include "GMD Field Probe.h"
#include "UserInterface.h"
#pragma endregion

#pragma region STD Includes
#pragma endregion

#include "Version.h"

#pragma region ROOT Includes
#include <TROOT.h>
#include <TApplication.h>
#pragma endregion

#ifdef _DEBUG
//Here: Put the Debug only limiation 
#endif


// The one and only application object
CWinApp theApp;
TApplication* theTApp;
using namespace std;
UserInterface* userInterface;

int _tmain(int argc, char **argv)
{
	int nRetCode = 0;
	HMODULE hModule = ::GetModuleHandle(NULL);

	if (hModule != NULL)
	{
		// initialize MFC and print and error on failure
		if (!AfxWinInit(hModule, NULL, ::GetCommandLine(), 0))
		{
			// TODO: change error code to suit your needs
			_tprintf(_T("Fatal Error: MFC initialization failed\n"));
			nRetCode = 1;
		}
		else
		{			

			//Console Application Operation:
			//===============================================
			// ROOT (Platform Free) Sub Application :
			if (gROOT->IsBatch()) {
				fprintf(stderr, "%s: cannot run in batch mode\n", argv[0]);
				return 1;
			}

			//Version declaration
			printf("\n===========================================================\n");
			printf("Current Application Version: ");
			printf(VER_FILE_VERSION_STR);
			printf("\nTarget ROOT Version: 5.34.25\n");
			printf("===========================================================\n\n");

			theTApp = new TApplication("App", &argc, argv);					
			// Try to Initialise the UserInterface Module:
#ifdef _USER_INTERFACE_MODULE
			try
			{
				userInterface = new UserInterface(); //#LEAK
				userInterface->UserInterfaceInitialise();
				printf("CC:> User Interface Initialised\n"); //#LOG
			}
			catch (int e)
			{
				printf("CC:> ERROR: User Interface Initialisation FAILED\n"); //#LOG
			}
#endif

			theTApp->Run();	
			
			//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
			//===============================================
		}
	}
	else
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: GetModuleHandle failed\n"));
		nRetCode = 1;
	}

	return nRetCode;
}
