
#pragma region Project Includes
#include "stdafx.h"
#include "MainFrame.h"
#pragma endregion 

ClassImp(MainFrame);

//General Controls:
TGStatusBar			 *statBar;

//Capture Controls:
TRootEmbeddedCanvas	 *recanvasMonitoring;
TGPictureButton		 *btnpSaveParams;
TGPictureButton		 *btnpLoadParams;
TGComboBox			 *comboSensorType;
TGTextButton		 *btnCapture;
TGPictureButton		 *btnpSaveFile;
TGTextButton		 *btnSnapshot;
TGTextButton		 *btnMonitor;
TGTextEntry			 *txteExposure;
TGNumberEntry		 *numeGain;
TGShutterItem		 *sitemVisualisation;
TGShutterItem		 *sitemCapturing;
TGVerticalFrame		 *frameVLevel4;

MainFrame::MainFrame()
{
	
}

MainFrame::~MainFrame()
{

}

bool MainFrame::MainFrameInitialise()
{
	// #UNDOC
#pragma region LAYOUT

#pragma region BASIC LAYOUT
	// main frame:
	w = 715;
	frameMain = new TGMainFrame(gClient->GetRoot(), w, 340, kMainFrame | kVerticalFrame);
	frameMain->SetName("frameMain");
	frameMain->SetWMSizeHints(w, 580, w, 1190, w, 740);

	// composite frame:
	TGCompositeFrame *frameVLevel1 = new TGCompositeFrame(frameMain, w, 340, kVerticalFrame);
	frameVLevel1->SetName("frameVLevel1");

	// vertical frame:
	TGVerticalFrame *frameVLevel2 = new TGVerticalFrame(frameVLevel1, w, 340, kVerticalFrame);
	frameVLevel2->SetName("frameVLevel2");

	// status bar:
	statBar = new TGStatusBar(frameVLevel2, 1065, 18);
	statBar->SetName("statBar");
	frameVLevel2->AddFrame(statBar, new TGLayoutHints(kLHintsBottom | kLHintsExpandX));

	// horizontal frame:
	TGHorizontalFrame *frameHLevel3 = new TGHorizontalFrame(frameVLevel2, 1065, 318, kHorizontalFrame);
	frameHLevel3->SetName("frameHLevel3");

	// shutter:
	TGShutter *shtrCommandPanel = new TGShutter(frameHLevel3, kSunkenFrame);
	shtrCommandPanel->SetName("shtrCommandPanel");

	// "Capturing" shutter item:
	sitemCapturing = new TGShutterItem(shtrCommandPanel, new TGHotString("Capturing"), 0, kVerticalFrame);
	sitemCapturing->SetName("sitemCapturing");
	TGCompositeFrame *frameVCapturing = (TGCompositeFrame *)sitemCapturing->GetContainer();
	shtrCommandPanel->AddItem(sitemCapturing);

	// "Visualisation" shutter item:
	sitemVisualisation = new TGShutterItem(shtrCommandPanel, new TGHotString("Visualisation"), 1, kVerticalFrame);
	sitemVisualisation->SetName("sitemVisualisation");
	TGCompositeFrame *frameVVisualisation = (TGCompositeFrame *)sitemVisualisation->GetContainer();
	shtrCommandPanel->AddItem(sitemVisualisation);
	shtrCommandPanel->SetSelectedItem(sitemCapturing);
	shtrCommandPanel->Resize(152, 318);
	frameHLevel3->AddFrame(shtrCommandPanel, new TGLayoutHints(kLHintsExpandY));

	// vertical frame:
	frameVLevel4 = new TGVerticalFrame(frameHLevel3, 909, 314, kVerticalFrame);
	frameVLevel4->SetName("frameVLevel4");

	// "Monitoring" group frame:
	TGGroupFrame *groupMonitoring = new TGGroupFrame(frameVLevel4, "Monitoring");

	// embedded canvas:
	recanvasMonitoring = new TRootEmbeddedCanvas(0, groupMonitoring, 512, 512);
	Int_t wrecanvasMonitoring = recanvasMonitoring->GetCanvasWindowId();
	canvasMonitoring = new TCanvas("canvasMonitoring", 10, 10, wrecanvasMonitoring);
	recanvasMonitoring->AdoptCanvas(canvasMonitoring);
	groupMonitoring->AddFrame(recanvasMonitoring, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	groupMonitoring->SetLayoutManager(new TGVerticalLayout(groupMonitoring));
	//Strechting the Histogram across the whole canvas:
	canvasMonitoring->SetTopMargin(0);
	canvasMonitoring->SetBottomMargin(0);
	canvasMonitoring->SetRightMargin(0);
	canvasMonitoring->SetLeftMargin(0);


	// Wrapping up: 
	frameVLevel4->AddFrame(groupMonitoring, new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2));
	frameHLevel3->AddFrame(frameVLevel4, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX | kLHintsExpandY, 2, 2, 2, 2));
	frameVLevel2->AddFrame(frameHLevel3, new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX | kLHintsExpandY));
	frameVLevel1->AddFrame(frameVLevel2, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 2, 2, 2, 2));
	frameMain->AddFrame(frameVLevel1, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY));
	frameVLevel1->MoveResize(0, 0, w, 340); // #UNDOC

#pragma endregion put lower level components here

#pragma region CAPTURE COMPONENTS

	//vvvvvvv----------------------------------------------------------------------------------------------vvvvvvvvvvvvvvvvvv
	TGLayoutHints *lhintsHorisontalStack = new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsExpandX, 5, 10, 5, 2);
	TGLayoutHints *lhintsStack0 = new TGLayoutHints(kLHintsTop | kLHintsLeft, 3, 0, 0);

	// horizontal frame  stack 0:
	TGHorizontalFrame *frameHCaptStack0 = new TGHorizontalFrame(frameVCapturing, 760, 26, kHorizontalFrame);
	frameHCaptStack0->SetBackgroundColor(frameVCapturing->GetBackground());
	frameHCaptStack0->SetName("frameHCaptStack1");

	// SaveParams button:
	btnpSaveParams = new TGPictureButton(frameHCaptStack0, gClient->GetPicture("save.xpm"), 11);
	btnpSaveParams->Connect("Clicked()", "UserInterface", this, "SaveParams()");
	btnpSaveParams->SetToolTipText("Save current paramiters");
	frameHCaptStack0->AddFrame(btnpSaveParams, lhintsStack0);

	// LoadParams button:  
	btnpLoadParams = new TGPictureButton(frameHCaptStack0, gClient->GetPicture("open.xpm"), 11);
	btnpLoadParams->Connect("Clicked()", "UserInterface", this, "LoadParams()");
	btnpLoadParams->SetToolTipText("Load most recently saved paramiters");
	frameHCaptStack0->AddFrame(btnpLoadParams, lhintsStack0);

	// Sensors combobox:
	comboSensorType = new TGComboBox(frameHCaptStack0);
	comboSensorType->AddEntry("2048: 1", 0);
	comboSensorType->AddEntry("1024: 2", 1);
	comboSensorType->AddEntry("512 : 4", 2);
	comboSensorType->Resize(80, 20);
	comboSensorType->Select(0);
	frameHCaptStack0->AddFrame(comboSensorType, lhintsStack0);
	frameVCapturing->AddFrame(frameHCaptStack0, lhintsHorisontalStack);
	//^^^^^^^^^^^^------------------------------------------------------------------------------------------^^^^^^^^^^^^

	//vvvvvvv----------------------------------------------------------------------------------------------vvvvvvvvvvvvvvvvvv
	TGLayoutHints *lhintsLabels = new TGLayoutHints(kLHintsLeft | kLHintsCenterY, 0, 0, 0, 0);
	TGLayoutHints *lhintsEntrys = new TGLayoutHints(kLHintsRight | kLHintsTop, 3, 10, 0, 0);

	// horizontal frame stack 1:
	TGHorizontalFrame *frameHCaptStack1 = new TGHorizontalFrame(frameVCapturing, 760, 26, kHorizontalFrame);
	frameHCaptStack1->SetBackgroundColor(frameVCapturing->GetBackground());
	frameHCaptStack1->SetName("frameHCaptStack1");

	// #UNDOC
	TGLabel *lblGain = new TGLabel(frameHCaptStack1, "Gain:");
	lblGain->SetTextJustify(36);
	lblGain->SetMargins(3, 0, 0, 0);
	lblGain->SetWrapLength(-1);
	lblGain->SetTextColor(0xF5F5F5);
	lblGain->SetBackgroundColor(frameVCapturing->GetBackground());
	frameHCaptStack1->AddFrame(lblGain, lhintsLabels);

	// #UNDOC
	numeGain = new TGNumberEntry(frameHCaptStack1, (Double_t)0, 6, -1, (TGNumberFormat::EStyle) 5);
	numeGain->SetName("numeGain");
	numeGain->SetIntNumber(1);
	numeGain->SetNumLimits(TGNumberFormat::kNELLimitMinMax);
	numeGain->SetLimitValues(1, 10);
	numeGain->SetWidth(60);
	frameHCaptStack1->AddFrame(numeGain, lhintsEntrys);
	frameVCapturing->AddFrame(frameHCaptStack1, lhintsHorisontalStack);
	//^^^^^^^^^^^^------------------------------------------------------------------------------------------^^^^^^^^^^^^

	//vvvvvvv----------------------------------------------------------------------------------------------vvvvvvvvvvvvvvvvvv
	// horizontal frame stack 2:
	TGHorizontalFrame *frameHCaptStack2 = new TGHorizontalFrame(frameVCapturing, 760, 26, kHorizontalFrame);
	frameHCaptStack2->SetBackgroundColor(frameVCapturing->GetBackground());
	frameHCaptStack2->SetName("frameHCaptStack2");
	// #UNDOC
	TGLabel *lblExposure = new TGLabel(frameHCaptStack2, "Exposure:");
	lblExposure->SetTextJustify(36);
	lblExposure->SetTextColor(0xF5F5F5);
	lblExposure->SetBackgroundColor(frameVCapturing->GetBackground());
	lblExposure->SetMargins(3, 0, 0, 0);
	lblExposure->SetWrapLength(-1);
	frameHCaptStack2->AddFrame(lblExposure, lhintsLabels);
	// #UNDOC
	TGFont *ufont;         // will reflect user font changes
	ufont = gClient->GetFont("-*-helvetica-medium-r-*-*-12-*-*-*-*-*-iso8859-1");
	TGGC   *uGC;           // will reflect user GC changes

	// graphics context changes:
	GCValues_t valentrExposure;
	valentrExposure.fMask = kGCForeground | kGCBackground | kGCFillStyle | kGCFont | kGCGraphicsExposures;
	gClient->GetColorByName("#000000", valentrExposure.fForeground);
	gClient->GetColorByName("#c0c0c0", valentrExposure.fBackground);
	valentrExposure.fFillStyle = kFillSolid;
	valentrExposure.fFont = ufont->GetFontHandle();
	valentrExposure.fGraphicsExposures = kFALSE;
	uGC = gClient->GetGC(&valentrExposure, kTRUE);

	// #UNDOC
	txteExposure = new TGTextEntry(frameHCaptStack2, new TGTextBuffer(15), -1, uGC->GetGC(), ufont->GetFontStruct(), kSunkenFrame | kDoubleBorder | kOwnBackground);
	txteExposure->SetMaxLength(4);
	txteExposure->SetAlignment(kTextRight);
	txteExposure->SetText("300");
	txteExposure->SetWidth(60);
	frameHCaptStack2->AddFrame(txteExposure, lhintsEntrys);
	frameVCapturing->AddFrame(frameHCaptStack2, lhintsHorisontalStack);
	//^^^^^^^^^^^^------------------------------------------------------------------------------------------^^^^^^^^^^^^

	//vvvvvvv----------------------------------------------------------------------------------------------vvvvvvvvvvvvvvvvvv
	// Monitor button stack 3:
	btnMonitor = new TGTextButton(frameVCapturing, "&Monitor");
	btnMonitor->SetMargins(5, 5, 5, 5);
	btnMonitor->Connect("Clicked()", "UserInterface", this, "Monitor()");
	btnMonitor->SetToolTipText("Attempt to start Monitoring\nGreen - Monitoring is in progress\nYellow - Monitoring is suspended\nRed - Check if sensor is ready");
	frameVCapturing->AddFrame(btnMonitor, new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 30, 30, 15, 2));

	// Snapshot button stack 4:
	btnSnapshot = new TGTextButton(frameVCapturing, "&Snapshot");
	btnSnapshot->SetMargins(5, 5, 5, 5);
	btnSnapshot->Connect("Clicked()", "UserInterface", this, "Snapshot()");
	btnSnapshot->SetToolTipText("Make a snapshot of a current frame");
	frameVCapturing->AddFrame(btnSnapshot, new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 30, 30, 0, 10));

	// horizontal frame stack 5:
	TGHorizontalFrame *frameHCaptStack5 = new TGHorizontalFrame(frameVCapturing, 760, 26, kHorizontalFrame);
	frameHCaptStack5->SetBackgroundColor(frameVCapturing->GetBackground());
	frameHCaptStack5->SetName("frameHCaptStack5");

	// Save picture button:
	btnpSaveFile = new TGPictureButton(frameHCaptStack5, "Icons/SaveFile.png", 11);
	btnpSaveFile->Connect("Clicked()", "UserInterface", this, "SetUpSaveFile()");
	frameHCaptStack5->AddFrame(btnpSaveFile, lhintsStack0);
	// Capture button: 
	btnCapture = new TGTextButton(frameHCaptStack5, "&Capture");
	btnCapture->SetMargins(5, 5, 5, 5);
	btnCapture->Connect("Clicked()", "UserInterface", this, "Capture()");
	frameHCaptStack5->AddFrame(btnCapture, lhintsStack0);

	frameVCapturing->AddFrame(frameHCaptStack5, new TGLayoutHints(kLHintsCenterX | kLHintsExpandX, 30, 30, 10, 2));
	//^^^^^^^^^^^^------------------------------------------------------------------------------------------^^^^^^^^^^^^

#pragma endregion put higher level components here

#pragma region Visualisation COMPONENTS

	//vvvvvvv----------------------------------------------------------------------------------------------vvvvvvvvvvvvvvvvvv
	TGLayoutHints *lhints2by2 = new TGLayoutHints(kLHintsLeft | kLHintsTop, 2, 2, 2, 2);
	TGLayoutHints *lhints2by2Center = new TGLayoutHints(kLHintsLeft | kLHintsTop | kLHintsCenterX, 2, 2, 2, 2);

	// horizontal frame stack 1:
	TGHorizontalFrame *frameHVisStack1 = new TGHorizontalFrame(frameVVisualisation, 484, 44, kHorizontalFrame);
	frameHVisStack1->SetName("frameHVisStack1");
	frameHVisStack1->SetBackgroundColor(frameVVisualisation->GetBackground());
	TGPictureButton *btnReuseV = new TGPictureButton(frameHVisStack1, gClient->GetPicture("Icons/ReuseV.png"));
	btnReuseV->SetToolTipText("Reopen recently recorded file");
	frameHVisStack1->AddFrame(btnReuseV, lhints2by2);
	TGPictureButton *btnpOpenV = new TGPictureButton(frameHVisStack1, gClient->GetPicture("Icons/OpenV.png"));
	btnpOpenV->SetToolTipText("Open a new file");
	frameHVisStack1->AddFrame(btnpOpenV, lhints2by2);

	frameVVisualisation->AddFrame(frameHVisStack1, lhints2by2Center);

	// horizontal frame stack 2:
	TGHorizontalFrame *frameHVisStack2 = new TGHorizontalFrame(frameVVisualisation, 484, 44, kHorizontalFrame);
	frameHVisStack2->SetName("frameHVisStack2");
	frameHVisStack2->SetBackgroundColor(frameVVisualisation->GetBackground());

	TGPictureButton *btnpStepBack = new TGPictureButton(frameHVisStack2, "Icons/StepBack.png");
	frameHVisStack2->AddFrame(btnpStepBack, lhints2by2);
	TGPictureButton *btnPlay = new TGPictureButton(frameHVisStack2, "Icons/Play.png");
	frameHVisStack2->AddFrame(btnPlay, lhints2by2);
	TGPictureButton *btnPauseV = new TGPictureButton(frameHVisStack2, "Icons/PauseV.png");
	frameHVisStack2->AddFrame(btnPauseV, lhints2by2);
	TGPictureButton *btnStepForward = new TGPictureButton(frameHVisStack2, "Icons/StepForward.png");
	frameHVisStack2->AddFrame(btnStepForward, lhints2by2);

	frameVVisualisation->AddFrame(frameHVisStack2, lhints2by2Center);
	//^^^^^^^^^^^^------------------------------------------------------------------------------------------^^^^^^^^^^^^
#pragma endregion put higher level components here

	// #UNDOC
	frameMain->SetMWMHints(kMWMDecorAll,
		kMWMFuncAll,
		kMWMInputModeless);
	//initialising functionality: 
	btnCapture->SetEnabled(false);
	btnSnapshot->SetEnabled(true);
	btnMonitor->SetBackgroundColor(0x7D807D);
	btnMonitor->SetForegroundColor(0x630000);
	//btnMonitor->SetFont(" - *-helvetica - medium - r - *-*-12 - *-*-*-*-*-iso8859 - 1"); //TODO: FONT CHANGE!!!!
	btnCapture->SetBackgroundColor(btnSnapshot->GetBackground());

	// initialising globals:
	SaveFile = ' ';

	// Mapping is in the end:
	frameMain->MapSubwindows();
	frameMain->Resize(1300, 340);
	frameMain->MapWindow();
	frameMain->SetWindowName("GMD Sensor Capture");
	frameMain->Connect("CloseWindow()", "MainFrame", this, "CloseWindow()");
	//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
#pragma endregion Loading Layout/ Initialising Variables, Flags, Component States


	// Smoothout the colors:
	const int Number = 3;
	Double_t Red[Number] = { 1.00, 0.00, 0.00 };
	Double_t Green[Number] = { 0.00, 1.00, 0.00 };
	Double_t Blue[Number] = { 1.00, 0.00, 1.00 };
	Double_t Length[Number] = { 0.00, 0.50, 1.00 };
	const int nb = 64;
	TColor::CreateGradientColorTable(Number, Length, Red, Green, Blue, nb);

	gStyle->SetOptStat("");					//Change style so that the histograms would not display the legend box
	gStyle->SetOptTitle(0);					//Change style to hide the title
	TH1::AddDirectory(kFALSE);
	btnSnapshot->SetEnabled(kTRUE);

	return true;
}

void MainFrame::CloseWindow() // #UNDOC
{
	//TODO: join the threads
	//TODO: Stop the services
	printf("  UI:> PLEASE WAIT. TERMINATING...");
	delete this;
	_exit(0);
	
}

void MainFrame::DisableSnapshotBtn()
{
	if (btnSnapshot)
	{
		btnSnapshot->SetEnabled(kFALSE); // #UNDOC
	}
}

void MainFrame::EnableSnapshotBtn()
{
	if (btnSnapshot)
	{
		btnSnapshot->SetEnabled(kTRUE); // #UNDOC
	}
}

void MainFrame::DisableMonitorBtn()
{
	if (btnSnapshot)
	{
		btnMonitor->SetEnabled(kFALSE); // #UNDOC
	}
}

void MainFrame::EnableMonitorBtn()
{
	if (btnSnapshot)
	{
		btnMonitor->SetEnabled(kTRUE); // #UNDOC
	}
}
