#pragma once

#pragma region ROOT Includes
#include "TStyle.h"
#include "TGFrame.h"
#include "TFile.h"
#include "TCanvas.h"
#include "TRootEmbeddedCanvas.h"
#include "TGButton.h"
#include "TGComboBox.h"
#include "TGNumberEntry.h"
#include "TGShutter.h"
#include "TGStatusBar.h"
#include "TGLabel.h"
#include "TColor.h"
#include "TH1.h"
#pragma endregion

class MainFrame : public TGMainFrame
{
public:
	MainFrame();
	~MainFrame();
	void CloseWindow();
	bool MainFrameInitialise();

	//Buttons Control:
	void DisableSnapshotBtn();
	void EnableSnapshotBtn();

	void DisableMonitorBtn();
	void EnableMonitorBtn();

	 TCanvas *canvasMonitoring;	 
	 TFile *fileCapture;

private:
	TGMainFrame	*frameMain;

	//Globals:
	TString	SaveFile;
	int w;											//width of the main frame


	//CLASSDEF must be here to be defined as a root class: http://root.cern.ch/drupal/content/adding-your-class-root-classdef 
	ClassDef(MainFrame, 1);

};

