#define __NUMBER_OF_FRAMES__					210           //Memory buffer

#pragma region Project Includes
#include "stdafx.h"
#include "SensorManager.h"
#pragma endregion

#include "TCondition.h"
#include "TThread.h"
#include "TF2.h"
#include "TCanvas.h"

ClassImp(SensorManager);

TH2* th21;
TH2* hist;
TCanvas* canvas;

int subarraywx = 2048 / 2;
int subarraywy = 2048 / 2;

long	CameraIndex = 0;
char	CameraName[64];
char	CameraID[64];
long	nCameras = 0;
long	NewestFrameIndex = -1;
long	TotalFrames = 0;
long	srcox = 0;
long	srcoy = 0;
long	srcwidth = 0;
long	srcheight = 0;
long	TimeOut;

int	x, y;
const WORD* srctopleft;
long srcrowbytes;
int numberOfFramesToAllocate;

bool Flip = true;
bool Flop = false;
int		lastBufferIndex = 0;
//Signals:
TCondition* FlipFlopCondition;

//Buffers
BYTE* memstoreFlip; //1024*1024*100frames*2largest binnign = 209715200
BYTE*  memstoreFlop; //1024*1024*2bytes*100frames*2largest binning
WORD* memstoreDEST; //FLIP ACTIVE FIRST
WORD* memstoreSOURCE; //FLOP READ FIRST
BYTE* memstoreLASTFRAME;

//Handles:
HANDLE hCurrentThread;
//Camera Data Structures:

//Camera Parameters:
float newexposure = 0.333257f;
void* pTop;
long pRowBytes;

//MonitoringThread properties:
TThread* monitoringThread;
bool IsMonitoring;
//^^^^^^^^
void* MonitoringThread(void*)
{
	//reset the states
	Flop = false;
	Flip = true;
	memstoreDEST = (WORD*)memstoreFlip;
	memstoreSOURCE = (WORD*)memstoreFlop; //FLOP READ FIRST
	long i = 0, errcount = 0;
	unsigned long readcycles = 0;

	printf("> Flip Active\n");
	while (IsMonitoring)
	{
		if (NewestFrameIndex == __NUMBER_OF_FRAMES__ - 1)
		{
			lastBufferIndex = __NUMBER_OF_FRAMES__;
			/*
			Flop = !Flop;
			Flip = !Flip;
			if (Flip)
			{
			printf("> Flip Active\n");
			memstoreDEST = (WORD*)memstoreFlip;
			}
			if (Flop)
			{
			printf("> Flop Active\n");
			memstoreDEST = (WORD*)memstoreFlop;
			}
			//FlipFlopCondition->Signal();
			*/
			NewestFrameIndex = -1;
			i = 1;
		}

		// Get the current transfer information status
		i++;
	}

	// Flip Flop one last time so that the treee fill would collect data from the 
	//	last used batch of memory buffer
	if (false)
	{
		lastBufferIndex = i;
		Flop = !Flop;
		Flip = !Flip;
		if (Flip)
		{
			memstoreDEST = (WORD*)memstoreFlip;
		}
		if (Flop)
		{
			memstoreDEST = (WORD*)memstoreFlop;
		}
		FlipFlopCondition->Signal();
	}

	printf("> Monitoring stopped\n");

	return 0;
}

SensorManager::SensorManager()
{
}

bool SensorManager::SensorManagerInitialise()
{
	if (OpenSensor())
	{
		printf(" SS:> Sensor Initialised\n"); //#LOG
		DisplaySensorProperties();
	}
	else
	{
		printf(" SS:> ERROR: Sensor Initialisation FAILED\n"); //#LOG	
	}
	return true;
}
SensorManager::~SensorManager()
{
	
}

bool SensorManager::OpenSensor()
{
	memDestMutex = new TMutex();
	
	return true;
}

bool SensorManager::CloseSensor()
{

	printf(" SS:>   Camera OFFLINE\n");
	return true;
}

void SensorManager::DisplaySensorProperties()
{

}

bool SensorManager::AquireFrame()
{	

	return true;
}

bool SensorManager::BeginMonitoringThread()
{

	if (monitoringThread)
	{
		return false; //#LOG
	}
	if (!((monitoringThread = new TThread("MonitoringThraed", MonitoringThread))))
	{
		return false; //#LOG
	}

	IsMonitoring = true;

	//Prepare Camera
	if (!PrepareSensor(true))
	{
		return false; //#LOG
	}

	monitoringThread->Run();
	return true;
}

bool SensorManager::StopMonitoringThread()
{
	IsMonitoring = false;  
	monitoringThread->Join();
	monitoringThread->Delete();
	return true;
}

bool SensorManager::PrepareSensor(bool isSequence)
{

	return true;
}

/*/Test Canvas
TF2 *f2 = new TF2("f2", "xygaus + xygaus(5) + xylandau(10)", -4, 4, -4, 4);
Double_t params[] = { 130, -1.4, 1.8, 1.5, 1, 150, 2, 0.5, -2, 0.5, 3600, -2, 0.7, -3, 0.3 };
f2->SetParameters(params);
TH2F* h2 = new TH2F("h2", "xygaus + xygaus(5) + xylandau(10)", 20, -4, 4, 20, -4, 4);
h2->SetFillColor(46);
h2->FillRandom("f2", 40000);
h2->Draw();
*/