#pragma once
#define _SENSOR_MANAGER  // let  the program know that the module exists

#pragma region Project includes
#include "MainFrame.h"
#include "TH2.h"
#include "TMutex.h"
#pragma endregion 

class SensorManager : public TObject
{
public:
	SensorManager();
	~SensorManager();

	bool SensorManagerInitialise();
	bool AquireFrame();
	bool BeginMonitoringThread();
	bool StopMonitoringThread();
	TMutex* memDestMutex;

private:

	//#DEBUG:
	float userDefinedExposure = 0.05f;
	
	//Camera Settings:
	double exposure = 0.333257;
	int binning = 2;
	int subarrayox = 0;
	int subarrayoy = 0;
	int subarraywx = 2048;
	int subarraywy = 2048;

	//Methods:
	bool OpenSensor();
	bool CloseSensor();

	void DisplaySensorProperties();
	bool PrepareSensor(bool isSequence);
	bool UnloadSensor();

	//Flags:

	ClassDef(SensorManager, 1);
};

