#pragma region Project Includes
#include "stdafx.h"
#include "UserInterface.h"
#include "TH2.h"
#include "TF2.h"
#pragma endregion


ClassImp(UserInterface);

TH2* th2;
bool*  pIsCanvasUpdating;
TCanvas* canvasToUpdate;
void* CanvasUpdate(void*)
{
	while (pIsCanvasUpdating)
	{
		if (canvasToUpdate && canvasToUpdate->IsModified())
		{
			canvasToUpdate->Update();			
		}
		else if (!canvasToUpdate)
		{
			pIsCanvasUpdating = false;
		}
		gSystem->Sleep(100);
		gSystem->ProcessEvents();
	}
	return 0;
}

UserInterface::UserInterface()
{
	
}

UserInterface::~UserInterface()
{
}

bool UserInterface::UserInterfaceInitialise()
{
	//Append Main Frame GUI:
	if (mainFrame = new MainFrame())
	{
		mainFrame->MainFrameInitialise();
		printf(" UI:> Main Frame Constructed\n"); //#LOG
	}
	else
	{
		printf(" UI:> ERROR: Main Frame Construction FAILD\n"); //#LOG
	}
	th2 = new TH2S(
		"2dHisto",
		"Single SnapShot",
		129,
		0.0,
		1024.0,//516.0,//2048.0,   //x
		129,
		0.0,
		1024.0//516.0//2048.0    //y
		);

	((TCanvas*)gROOT->GetListOfCanvases()->FindObject("canvasMonitoring"))->cd();
	th2->Draw("col");

	//Cpntrol Center Initiation:
	controlCenter = new ControlCenter(); //Initialise Control Center and let it run
	controlCenter->ControlCenterInitialise();

	//Fileds Initiation:
	pIsCanvasUpdating = &IsCanvasUpdating;
	if (mainFrame->canvasMonitoring)
	{
		canvasToUpdate = mainFrame->canvasMonitoring;
	}

	//Canvas Update Initiation:
	InitialiseCanvasUpdate();
	return true;
}

bool UserInterface::InitialiseCanvasUpdate()
{
	IsCanvasUpdating = true;
	if (!(canvasUpdatingThread = new TThread("canvasUpdatingThread", CanvasUpdate))) //#LEAK
	{
		return false;
	};
	canvasUpdatingThread->Run();
	return true;
}

void UserInterface::Snapshot()
{	
	mainFrame->DisableMonitorBtn();
	mainFrame->DisableSnapshotBtn();
	if (!(controlCenter->SnapShot()))
	{
		mainFrame->EnableMonitorBtn();
		mainFrame->EnableSnapshotBtn();
		return; //#LOG Something bad happened
	}
	mainFrame->EnableMonitorBtn();
	mainFrame->EnableSnapshotBtn();
}
void UserInterface::Monitor()
{
	if (!IsMonitoringUI) //Start Monitoring
	{		
		
		controlCenter->BeginMonitoring();
		mainFrame->DisableSnapshotBtn();
		IsMonitoringUI = true;
	}
	else //Stop monitoring
	{
		
		controlCenter->StopMonitoring();
		mainFrame->EnableSnapshotBtn();
		IsMonitoringUI = false;
	}
}
void UserInterface::Capture()
{
}
void UserInterface::SetUpSaveFile()
{
}
void UserInterface::SaveParams()
{
}
void UserInterface::LoadParams()
{
}