#pragma once
#define _USER_INTERFACE_MODULE  // let  the program know that the module exists

#pragma region Project includes
#include "MainFrame.h"
#include "ControlCenter.h"
#pragma endregion 

#pragma region ROOT Includes
#include <TThread.h>
#pragma endregion

class UserInterface : public TObject
{
public:
	UserInterface();
	~UserInterface();
	
	//Methods:
	bool UserInterfaceInitialise();
	bool InitialiseCanvasUpdate();   

	//Slots:
	void Monitor();
	void Snapshot();
	void Capture();
	void SaveParams();
	void LoadParams();
	void SetUpSaveFile();

private:

	//Flags:
	bool IsSaveFileDefined = false;
	bool IsSensorConnected = false;
	bool IsMonitoringUI = false;
	bool IsDialogOpen = false;
	bool IsCapturing = false;
	bool IsCanvasUpdating = false;

	//Control Center:
	ControlCenter* controlCenter;

	//ROOT:
	MainFrame* mainFrame;
	TThread* canvasUpdatingThread;


	ClassDef(UserInterface, 1); //use 0 because class wouldn't be serialised https://root.cern.ch/root/Using.html
};

